﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Highlighter
{
    /// <summary>
    /// A basic text parser, looks for Flanderisms and censors.
    /// </summary>
    public class FlandersParser : Keyoti.RapidSpell.RapidSpellChecker
    {
        Hashtable dictionary = new Hashtable();
        string suggestion = null;




        Keyoti.RapidSpell.FrameWorkSpecific.AdvancedTextBoundary wordIterator = new Keyoti.RapidSpell.FrameWorkSpecific.AdvancedTextBoundary();

        public FlandersParser()
        {
            //load dictionary of flanderisms, a real offensive word parser would of course
            //have a list of offensive words here.
            dictionary.Add("gosh", "****");
            dictionary.Add("darn", "****");
            dictionary.Add("co-winky-dink", "**-*****-****");
            dictionary.Add("doodle", "*****");
            dictionary.Add("neighboreeny", "neighbor");
            dictionary.Add("hi-diddly-ho", "hello");
            IgnoreIncorrectSentenceCapitalization = true;
            IgnoreInEnglishLowerCaseI = true;
            WarnDuplicates = false;
            TextBoundary = wordIterator;

        }



        protected override bool LookUpMainDictionary(string query)
        {
            return !dictionary.ContainsKey(query); //opposite to how spell check works - highlight if is in dictionary, hence the not (!)
        }


        public override ArrayList FindSuggestions()
        {
            ArrayList s = new ArrayList();
            if (suggestion != null) s.Add(suggestion);
            return s;
        }
    }
}
